<?php
	echo "<h2>Browsers List</h2>";
	
	$TimePrefix = GetTimePrefix();
		
	$GLFN = realpath(dirname(__FILE__) . "/../GlobalLog-" . $TimePrefix . ".txt");
	if(file_exists($GLFN)){
		echo "<p>Analysing log file for the epoch starting on " . date("d M y", $TimePrefix) . ".</p>";
		
		//Read the log file and get countries list
		
		$FA = file($GLFN);
		$i=0;
		$BrowserArray = array();
		for($i=count($FA)-1; $i>=0; $i--){ //we start at count-1 because the very first one - the last line in the log - is empty
			//echo "<div>$i:$FA[$i]<br></div>";
			//Clean up the data and display it!
			//	$s = "$script_name\t$request_uri\t$referer\t$user_agent\t$remote\t". time() . "\n";

			list($ActualURL, $RequestedURL, $Referer, $UA, $Remote, $HitTime) = explode("\t", trim($FA[$i]));
				
			//IE (4 of them)
			if(stristr($UA, "MSIE 6.0")){
				$BrowserArray["MSIE 6.0"]++;
				}
			elseif(stristr($UA, "MSIE 5.5")){
				$BrowserArray["MSIE 5.5"]++;
				}
			elseif(stristr($UA, "MSIE 5.01")){
				$BrowserArray["MSIE 5.01"]++;
				}
			elseif(stristr($UA, "MSIE 5.")){
				$BrowserArray["MSIE 5.x"]++;
				}
			
			//Mac (5 of them)
			elseif(stristr($UA, "Safari")){ //Safari MUST be tested before "Gecko" because its UA contains "Gecko-like"
				$BrowserArray["OS X Safari"]++;
				}
			elseif(stristr($UA, "Omniweb")){ //also contains "gecko" in its UA
				$BrowserArray["Omniweb"]++;
				}
			elseif(stristr($UA, "Camino")){
				$BrowserArray["Mozilla Camino"]++;
				}
			elseif(stristr($UA, "Chimera")){
				$BrowserArray["Mozilla Chimera"]++;
				}
			elseif(stristr($UA, "iCab")){
				$BrowserArray["iCab"]++;
				}
			
			//Mozilla & derivatives, excluding the Mac ones... (10 of them)
			elseif(stristr($UA, "Firebird")){
				$BrowserArray["Mozilla Firebird"]++;
				}
			elseif(stristr($UA, "Phoenix")){
				$BrowserArray["Mozilla Phoenix (now Firebird)"]++;
				}
			elseif(stristr($UA, "Epiphany")){
				$BrowserArray["Mozilla Epiphany"]++;
				}
			elseif(stristr($UA, "Galeon")){
				$BrowserArray["Mozilla Galeon"]++;
				}
			elseif(stristr($UA, "K-Meleon")){
				$BrowserArray["Mozilla K-Meleon"]++;
				}
			elseif(stristr($UA, "Netscape6")){
				$BrowserArray["Netscape 6.x"]++;
				}
			elseif(stristr($UA, "Netscape/7")){
				$BrowserArray["Netscape 7.x"]++;
				}
			elseif(stristr($UA, "Netscape")){
				$BrowserArray["Netscape (not 6.x or 7.x)"]++;
				}
			elseif(stristr($UA, "Gecko")){
				$BrowserArray["Gecko-based"]++;
				}
			elseif(stristr($UA, "Mozilla")){ //This can be anything. 
				$BrowserArray["'Mozilla' (Could be anything)"]++;
				}
				
			//Others... (7 + unknown)
			elseif(stristr($UA, "Konqueror")){
				$BrowserArray["Konqueror"]++;
				}
			elseif(stristr($UA, "Opera")){
				$BrowserArray["Opera"]++;
				}
			elseif(stristr($UA, "Amaya")){
				$BrowserArray["Amaya"]++;
				}
			elseif(stristr($UA, "Oregano")){
				$BrowserArray["Oregano"]++;
				}
			elseif(stristr($UA, "Xenu")){ //The link checker
				$BrowserArray["Xenu"]++;
				}
			elseif(stristr($UA, "Links")){
				$BrowserArray["Links"]++;
				}
			elseif(stristr($UA, "Lynx")){
				$BrowserArray["Lynx"]++;
				}
			else{
				$StrOthers .= "$UA<br />";
				$BrowserArray["Unrecognised"]++;
				}
			}
		$OSCount = 0;
		if($BrowserArray["Unrecognised"]){
			$OSCount = count($BrowserArray)-1; //to exclude the Unknowns
			}
		else{
			$OSCount = count($BrowserArray);
			}
		echo "<p>Total detected browsers: $OSCount</p>";		
		?>
		<table cellpadding="0" cellspacing="0" border="0" class="DataTable">
		<tr>
			<td class="CountsTableHeader">Browser</td>
			<td class="CountsTableHeader">No. of User-agents</td>
		</tr>
		<?php
		
		//Display here
		
		$RowCount = 0;
		arsort($BrowserArray);
		while (list($key, $val) = each($BrowserArray)) {
			if($RowCount%2!=0){
				echo "<tr class=\"OddRow\"><td class=\"LeftDataTD\">$key</td><td class=\"DataTD\">$val</td></tr>";
				}
			else{
				echo "<tr><td class=\"LeftDataTD\">$key</td><td class=\"DataTD\">$val</td></tr>";
				}
			$RowCount++;
			}
		echo "</table>";
		//echo "<div>$StrOthers</div>";
		}
	else{
		echo "<p>There are no hits in the current epoch.</p>";
		}
?>
<hr />
<div class="PluginInfo">PHPCounter 7 Core Plugin Browsers List - 16Dec03 Release</div>
<div class="PluginInfo">Copyright &copy; 2003 Pierre Far. Free for non-commercial use.</div>