<?php

	echo "<h2>Operating Systems List</h2>";
	
	$TimePrefix = GetTimePrefix();
		
	$GLFN = realpath(dirname(__FILE__) . "/../GlobalLog-" . $TimePrefix . ".txt");
	if(file_exists($GLFN)){
		echo "<p>Analysing log file for the epoch starting on " . date("d M y", $TimePrefix) . ".</p>";
		
		//Read the log file and get countries list
		
		$FA = file($GLFN);
		$i=0;
		$OSArray = array();
		$OSCount = 0;
		$TotalWindows = 0;
		$TotalOther = 0;
		for($i=count($FA)-1; $i>=0; $i--){ //we start at count-1 because the very first one - the last line in the log - is empty
			//echo "<div>$i:$FA[$i]<br></div>";
			//Clean up the data and display it!
			//	$s = "$script_name\t$request_uri\t$referer\t$user_agent\t$remote\t". time() . "\n";

			list($ActualURL, $RequestedURL, $Referer, $UA, $Remote, $HitTime) = explode("\t", trim($FA[$i]));
				
			//Here
			$UA = strtolower($UA);
			if(stristr($UA, "windows nt 5.1")){
				$OSArray["Windows XP"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "windows nt 5.0")){
				$OSArray["Windows 2000"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "windows nt 4")){
				$OSArray["Windows NT 4"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "windows nt") || stristr($UA, "windows-nt")){
				$OSArray["Windows NT"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "win98") || stristr($UA, "windows 98")){
				$OSArray["Windows 98"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "win95") || stristr($UA, "windows 95")){
				$OSArray["Windows 95"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "windows 3.1") || stristr($UA, "win16")){
				$OSArray["Windows 3.x"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "windows me")){
				$OSArray["Windows ME"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "win9x")){
				$OSArray["Windows 9x"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "windows ce")){
				$OSArray["Windows CE"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "windows")){
				$OSArray["Windows"]++;
				$TotalWindows++;
				}
			elseif(stristr($UA, "os x")){
				$OSArray["OS X"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "mac")){
				$OSArray["Mac (PPC)"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "linux")){
				$OSArray["Linux"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "freebsd")){
				$OSArray["FreeBSD"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "sunos")){
				$OSArray["SunOS"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "irix")){
				$OSArray["IRIX"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "risc os")){
				$OSArray["RISC OS"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "hp-ux")){
				$OSArray["HP-UX"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "unix")){
				$OSArray["Unix"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "amigaos")){
				$OSArray["AmigaOS"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "webtv")){
				$OSArray["WebTV"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "os/2")){
				$OSArray["OS/2"]++;
				$TotalOther++;
				}
			elseif(stristr($UA, "palmos")){
				$OSArray["Palm OS"]++;
				$TotalOther++;
				}
			else{
				$OSArray["Unrecognised"]++;
				}
			}
			
		$OSCount = count($OSArray);
		$OSTotal = $TotalWindows + $TotalOther;
		$Unrecognised = 0;
		if($OSArray["Unrecognised"]){
			$Unrecognised = count($FA) - 1 - $OSTotal;
			}	
			
		echo "<p>Total number of detected operating systems: $OSCount<br/>&nbsp;For a total of $OSTotal hits with a recognised OS<br/>&nbsp;With a total of $Unrecognised with an unrecognised OS.</p>";
		?>
		<table cellpadding="0" cellspacing="0" border="0" class="DataTable">
		<tr>
			<td class="CountsTableHeader">Operating System</td>
			<td class="CountsTableHeader">Number of Hits</td>
		</tr>
		<?php
		
		//Display here
		
		$RowCount = 0;
		arsort($OSArray);
		while (list($key, $val) = each($OSArray)) {
			if($RowCount%2!=0){
				echo "<tr class=\"OddRow\"><td class=\"LeftDataTD\">$key</td><td class=\"DataTD\">$val</td></tr>";
				}
			else{
				echo "<tr><td class=\"LeftDataTD\">$key</td><td class=\"DataTD\">$val</td></tr>";
				}
			$RowCount++;
			}
		echo "</table>";
		echo "<p>Total Windows: $TotalWindows (" .  number_format(100 * $TotalWindows/$OSTotal, 2, ".", "")."% of total).</p>";
		echo "<p>Total Other: $TotalOther (" .  number_format(100 * $TotalOther/$OSTotal, 2, ".", "") ."% of total) excluding the unrecognised hits.</p>";
		echo "<p>Total detected operating systems: $OSTotal.</p>";
		}
	else{
		echo "<p>There are no hits in the current epoch.</p>";
		}
?>
<hr />
<div class="PluginInfo">PHPCounter 7 Core Plugin Operating Systems List - 08Dec03 Release</div>
<div class="PluginInfo">Copyright &copy; 2003 Pierre Far. Free for non-commercial use.</div>