<?php
	echo "<h2>Counts for all Pages</h2>";
	$LogFileCount = 1;
	$CountsPath = realpath(dirname(__FILE__) . "/../");
	
	$handle = @opendir($CountsPath) or die("Directory $CountsPath not found.");
	
	$TimePrefix = GetTimePrefix();
	
	if($TimePrefix){
		//fixes a bug when resetting the counter by setting dawn=0;
		echo "<p>Analysing log file for the Epoch that started on " . date("d M y", $TimePrefix) . ".</p>";
		}
	else{
		echo "<p>The counter was recently reset, but no new hits have been registered yet.</p>";
		}
	
	/*
	Now calculate the time span that we are dealing with.
	
	If DAWN > EpochPrefix then we are dealing with an previous epoch
		TIME_SPAN CANNOT BE CALCULATED (the epoch length cannot be determined)
	Elseif NOW > DAWN then we are dealing with the current epoch
		TIME_SPAN = NOW - DAWN
	*/
	
	$Dn = GetDawn();
	if($Dn){
		$TSpan = 0; //We default to 1 not 0 because we don't want to be dividing by zero later on (and it makes logical sense)
		
		if($Dn == $TimePrefix){
			//Current epoch...
			$Tm = time();
			
			$TSpan = ($Tm -$Dn)/(60 * 60 * 24); //converted to days...
			$Hrs = number_format((($TSpan - floor($TSpan)) * 24), 2, ".", ""); //Converted to hours...
			//echo "<p>Dn: $Dn</p><p>Time: $Tm</p><p>TS: $TSpan</p><p>F-TS: " . floor($TSpan) . "</p><p>HR: $Hrs</p>";
			echo "<p>Time into current Epoch: " . floor($TSpan) . " days(s) and " . $Hrs . " hour(s).</p>";
			}
		else{
			echo "<p>Analysing an 'old' Epoch (not the current one). Hit rates will not be calculated because the Epoch length is not known.</p>";
			}
		
		/*
		if($Dn > $TimePrefix){
			//Old epoch.
			echo "<p>Analysing an 'old' Epoch (not the current one). Hit rates will not be calculated because the Epoch length is not known.</p>";
			}
		else{
			$Tm = time();
			$TSpan = trim(number_format(($Tm - $Dn)/(60 * 60 *24), 2, ".", ""));
			
			$Hrs = number_format((24*(ceil($TSpan) - floor($TSpan))), 0, ".", "");
			echo "<p>Time into the current Epoch: " . floor($TSpan) . " day(s) and " . $Hrs . " hour(s).</p>";
			}
		*/
		
		$ShowAllCounts_TotalCount = 0;
		
		$AllCounts = array();
		
		while($entry = readdir($handle)){
			if($entry != ".." && $entry != "."){
				$PathParts = pathinfo($entry);
				if($PathParts["extension"] == "count"){
					if(strstr($entry, $TimePrefix . "--")){
						$FA = file($entry);
						$AllCounts[$FA[0]] = $FA[1];
						$LogFileCount++;
						$GLOBALS["ShowAllCounts_TotalCount"]+=trim($FA[1]);
						}
					}
				}
			}
		$Pages = $LogFileCount - 1;
		echo "<p>Total number of pages tracked: $Pages page(s).</p>";
		
		
		if($TSpan){
			if($TSpan < 1){
				//we are in the first day of tracking
				$TSpan = 1;
				}
			echo "<p>Total count in this Epoch is: " . $GLOBALS["ShowAllCounts_TotalCount"] . " (" . number_format($GLOBALS["ShowAllCounts_TotalCount"]/$TSpan, 2, ".", "") . " hits per day).</p>";
			}
		else{
			echo "<p>Total count in this Epoch is: " . $GLOBALS["ShowAllCounts_TotalCount"]. "</p>";
			}
		
		closedir($handle);
		
		echo "<p>Counts list of individual pages in descending order (i.e. most visited first).</p>";
		
		echo "<table class=\"CountsTable\" cellpadding=\"0\" cellspacing=\"0\">\n";
		echo "<tr><td class=\"CountsTableHeader\">&nbsp;</td><td class=\"CountsTableHeader\">Page URL</td><td class=\"CountsTableHeader\"><div>Count</div><div>(% of total)</div></td><td class=\"CountsTableHeader\"><div>Rate</div><div>(hits per day)</div></td><td>&nbsp;</td></tr>\n";	
	
		arsort($AllCounts);
		reset($AllCounts);
		$RowCount = 0;
		while (list($key, $val) = each($AllCounts)) {
			if($RowCount%2!=0){
					echo "<tr class=\"OddRow\"><td class=\"LeftDataTD\">". ($RowCount + 1) . "</td><td class=\"LeftDataTD\"><a href=\"". $key ."\">". $key ."</a></td><td class=\"LeftDataTD\">". $val ."<br />(" . number_format(100*$val/$GLOBALS["ShowAllCounts_TotalCount"], 2, ".", "") . "%)</td>";
					if($TSpan){
						echo "<td class=\"DataTD\">" . trim(number_format(($val)/$TSpan, 2, ".", "")) . " hpd</td>";
						}
					else{
						echo "<td class=\"DataTD\">---</td>";
						}
					echo "<td class=\"DataTD\"><a href=\"index.php?Plugin=Filter&amp;EpochPrefix=" . $TimePrefix . "&amp;FilterActualURL=". $key ."\">Filter</a></td>";
					echo "</tr>\n";
				}
				else{
					echo "<tr><td class=\"LeftDataTD\">". ($RowCount + 1) . "</td><td class=\"LeftDataTD\"><a href=\"". $key ."\">". $key ."</a></td><td class=\"LeftDataTD\">". $val ."<br />(" . number_format(100*$val/$GLOBALS["ShowAllCounts_TotalCount"], 2, ".", "") . "%)</td>";
					if($TSpan){
						echo "<td class=\"DataTD\">" . trim(number_format($val/$TSpan, 2, ".", "")) . " hpd</td>";
						}
					else{
						echo "<td class=\"DataTD\">---</td>";
						}
					echo "<td class=\"DataTD\"><a href=\"index.php?Plugin=Filter&amp;EpochPrefix=" . $TimePrefix . "&amp;FilterActualURL=". $key ."\">Filter</a></td>";
					echo "</tr>\n";
				}
			$RowCount++;
			}
		echo "</table>";
	}
	else{
		echo "<p>There are no hits in the current epoch.</p>";
		}
?>
<hr />
<div class="PluginInfo">PHPCounter 7 Core Plugin Page Counts 2 - 20Dec03 Release</div>
<div class="PluginInfo">Copyright &copy; 2003 Pierre Far. Free for non-commercial use.</div>